######################################################################
# @@HEADER3_NANAMI@@
######################################################################

package Nana::GoogleSitemaps;
use strict;
use vars qw($VERSION);

$VERSION = '0.2';

# The constructor.
sub new {
	my ($class, %hash) = @_;
	my $self = {
		version => $hash{version},
		encoding => $hash{encoding},
	};
	return bless $self, $class;
}

# Adding item.
sub add_item {
	my ($self, %hash) = @_;
	push(@{$self->{items}}, \%hash);
	return $self->{items};
}

#
sub as_string {
	my ($self) = @_;
	my $doc = <<"EOD";
<?xml version="1.0" encoding="utf-8"?>
<urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9">

@{[
 map {
  qq{
   <url>
   <loc>$_->{link}</loc>
   <lastmod>$_->{dc_date}</lastmod>
   <priority>$_->{priority}</priority>
   @{[$_->{changefreq} ne '' ? "<changefreq>$_->{changefreq}</changefreq>" : ""]}
   </url>
  }
  } @{$self->{items}}
]}
</urlset>
EOD
}

1;
__END__
