######################################################################
# @@HEADER2_NEKYO@@
######################################################################
# google sitemaps
# based on PukiWiki Google Sitemaps by Terai Atsuhiro
# http://terai.xrea.jp/PukiWiki/Google.html
# http://www.google.com/webmasters/sitemaps/login
######################################################################

use Nana::GoogleSitemaps;

# always, hourly, daily, weekly, monthly, yearly, never
$sitemaps::freq="always"
	if(!defined($sitemaps::freq));

$sitemaps::defaultpriority="0.5"
	if(!defined($sitemaps::defaultpriority));

$sitemaps::defaultpriority_FrontPage="0.8"
	if(!defined($sitemaps::defaultpriority_FrontPage));

$sitemaps::defaultpriority_MenuPage="0.0"
	if(!defined($sitemaps::defaultpriority_MenuPage));

$sitemaps::defaultpriority_SysPage="0.0"
	if(!defined($sitemaps::defaultpriority_SysPage));

sub plugin_sitemaps_action {
	my $sitemaps = new Nana::GoogleSitemaps(
		version => '1.0',
		encoding => "UTF-8",
	);
#	my $recentchanges = $::database{$::RecentChanges};
	my $count = 0;

	&getbasehref;
	my $base=$::basehref;
	$base=~s/\/$//;

#	foreach (split(/\n/, $recentchanges)) {
#		last if ($count >= 10000);
#		/^\- (\d\d\d\d\-\d\d\-\d\d) \(...\) (\d\d:\d\d:\d\d) (.*?)\ \ \-/;    # data format
	foreach my $list(keys %::database) {
		my $title = &unarmor_name($list);
		my $escaped_title = &escape($title);
		my $link = $modifier_rss_link . &make_cookedurl($title);
		my $description = $escaped_title . &escape(&get_subjectline($title));
		my $t=$::database{"__update__" . $list};
		my $date=&date("Y-m-dTH:i:s", $t, "gmtime") . "Z";

		$link=~s!://!\t!g;
		$link=~s!//!/!g;
		$link=~s!\t!://!g;

		if(&is_readable($title) && $title!~/$::non_list/) {
			my $priority=$sitemaps::defaultpriority;
			if($title eq $::FrontPage) {
				$priority=$sitemaps::defaultpriority_FrontPage;
			} elsif($title=~/$::MenuBar|$::SideBar|$::TitleHeader|$::Header|$::Footer|$::BodyHeader|$::BodyFooter|$::SkinFooter/) {
				$priority=$sitemaps::defaultpriority_MenuPage;
			} elsif($title=~/$::SandBox|$::InterWikiName|$::InterWikiSandBox|$::ErrorPage|$::AdminPage|$::IndexPage|$::SearchPage|$::CreatePage|$::resource{help}/) {
				$priority=$sitemaps::defaultpriority_SysPage;
			}
			my $body=$::database{$list};
			if($body=~/#sitemaps\((\d\.\d)\)/) {
				$priority=$1;
			}
			$sitemaps->add_item(
				title => $escaped_title,
				link  => "$base$link",
				dc_date => $date,
				priority=> $priority,
				changefreq=> $sitemaps::freq,
			);
			$count++;
		}
	}
	# print RSS information (as XML).
	my $body=$sitemaps->as_string;
	if($::lang eq 'ja') {
		$body=&code_convert(\$body, 'utf8');
	}
	print &http_header("Content-type: text/xml");
	print $body;
	&close_db;
	exit;
}

sub plugin_sitemaps_inline {
	return ' ';
}

sub plugin_sitemaps_convert {
	return ' ';
}

1;
__END__
